package com.book.push.handler;

import com.book.dao.cps.pojo.*;
import com.book.dao.cpsshard.entity.Sign;
import com.book.dao.cpsshard.mapper.SignMapper;
import com.book.dao.cpsshard.pojo.example.SignExample;
import com.book.dao.utils.DateUtils;
import com.book.dao.utils.TimeUtil;
import com.book.push.cons.SiteCons;
import com.book.push.service.dao.*;
import com.book.push.service.push.PushService;
import com.book.push.service.wx.WxThirdPartService;
import me.chanjar.weixin.common.session.WxSessionManager;
import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.bean.kefu.WxMpKefuMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlOutMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlOutTextMessage;
import me.chanjar.weixin.mp.builder.kefu.NewsBuilder;
import me.chanjar.weixin.open.api.WxOpenMpService;
import me.chanjar.weixin.open.api.WxOpenService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.concurrent.TimeUnit;

import static me.chanjar.weixin.common.api.WxConsts.EventType;

/**
 * @author 点击菜单事件
 */
@Component
public class MenuHandler extends AbstractHandler {

    @Autowired
    private UserService userService;
    @Autowired
    private AdminConfigService adminConfigService;


    @Override
    public WxMpXmlOutMessage handle(WxMpXmlMessage wxMessage,
                                    Map<String, Object> context, WxMpService weixinService,
                                    WxSessionManager sessionManager) {

        if (EventType.VIEW.equals(wxMessage.getEvent())) {
            return null;
        }

        String appid = wxMessage.getToUser();
        User user = userService.selectByOpenId(wxMessage.getFromUser());

        Integer channelId = user.getChannelId();
        AdminConfig adminConfig = adminConfigService.selectByAdminId(channelId);

        Long id = user.getId();


        return msgAfterSing(wxMessage, appid, user.getOpenid());


    }

    private WxMpXmlOutMessage msgAfterSing(WxMpXmlMessage wxMessage, String appid, String openid) {
        //todo 签到后回复
        String msg = "";
//        String msg = "<a href=\"weixin://bizmsgmenu?msgmenucontent=签到&msgmenuid=0\">点我签到</a>";
        if ("签到".equals(wxMessage.getEventKey())) {
            msg = "<a href=\"weixin://bizmsgmenu?msgmenucontent=签到&msgmenuid=0\">\uD83D\uDC49\uD83D\uDC49点击领取免费书币</a>";

            WxMpXmlOutTextMessage wxMpXmlOutTextMessage = WxMpXmlOutMessage.TEXT().content(msg)
                    .fromUser(appid).toUser(openid)
                    .build();
            return wxMpXmlOutTextMessage;

        }
        return null;

    }


}
